/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description 		    : 1շʾ
 *******************************************************************************/

#include "CH57x_common.h"
#include "CH57xBLE_LIB.H"
#include "HAL.h"
#include "math.h"

__attribute__((aligned(4))) u32 MEM_BUF[BLE_MEMHEAP_SIZE/4];

#if (defined (BLE_MAC)) && (BLE_MAC == TRUE)
u8C MacAddr[6] = {0x84,0xC2,0xE4,0x03,0x02,0x02};
#endif

#define TX_DATA_SIZE  24
uint8_t TX_DATA[TX_DATA_SIZE] = {0x1,0x00,0x0, 0x0, 0xAB, 0x23,
                                 8,0x09,'z','g','-','T','E','S','T',
                                 8,0xff,'z','g',1,1,1,0,0
};

uint32_t g_DeviceId = 1;
uint16_t g_DeviceType = 9131;
//rf
#define SEND_PERIOD Period_4_S

void RF_2G4StatusCallBack( uint8 sta , uint8 crc, uint8 *rxBuf )
{

}

void rf_init(void){
    uint8 state;
    rfConfig_t rfConfig;

    rfConfig.accessAddress = 0x8E89BED6;  // ֹʹ0x55555555Լ0xAAAAAAAA ( 鲻24λתҲ601 )
    rfConfig.CRCInit = 0x555555;
    rfConfig.Channel = 39;
    //rfConfig.Frequency = 2480000;
    //rfConfig.LLEMode = LLE_MODE_BASIC|LLE_MODE_EX_CHANNEL; // ʹ LLE_MODE_EX_CHANNEL ʾ ѡ rfConfig.Frequency ΪͨƵ
    rfConfig.LLEMode = LLE_MODE_BASIC;
    rfConfig.rfStatusCB = RF_2G4StatusCallBack;
    state = RF_Config( &rfConfig );
    //PRINT("rf 2.4g init: %x\n",state);
}


int main()
{
    SetSysClock( CLK_SOURCE_PLL_60MHz );
    GPIOA_ModeCfg(GPIO_Pin_All,GPIO_ModeIN_Floating);
    GPIOB_ModeCfg(GPIO_Pin_All,GPIO_ModeIN_Floating);
    HAL_TimeInit();

    WWDG_SetCounter(0x0);
    WWDG_ResetCfg(ENABLE);

#ifdef DEBUG
    GPIOA_SetBits( bTXD1 );
    GPIOA_ModeCfg( bTXD1, GPIO_ModeOut_PP_5mA );
    UART1_DefInit( );
#endif
    PRINT("s\n");
    {
        //PRINT("%s\n",VER_LIB);
    }
    signed short RoughCalib_Value = 0;
    int adcSum = 0;
    int i = 0;
    //صѹ
    float vcc_bat_novref = 0;
    {
        ADC_InterBATSampInit();
        RoughCalib_Value = ADC_DataCalib_Rough();
        for( i = 0; i < 5; i++ )
        {
            adcSum += ADC_ExcutSingleConver() + RoughCalib_Value;      // 5
        }
        //(ADC/512-3)*Vref Vref=1.05V
        vcc_bat_novref = ((float)adcSum/5/512-3);
    }
    WWDG_SetCounter(0x0);
    if(vcc_bat_novref <= 2.3523/*2.47V*/){
        goto SLEEP;
    }


    CH57X_BLEInit( );
    RF_RoleInit( );
    rf_init();

    RF_Tx( TX_DATA,TX_DATA_SIZE, 0x02, 0xFF );
    RF_Tx( TX_DATA,TX_DATA_SIZE, 0x02, 0xFF );
    RF_Tx( TX_DATA,TX_DATA_SIZE, 0x02, 0xFF );

    WWDG_SetCounter(0x0);
    /*while(1){
        DelayMs( 200 );
        RF_Tx( TX_DATA,TX_DATA_SIZE, 0x02, 0xFF );
    }*/


SLEEP:
    PRINT( "e\n" );
    RF_Shut();
    //PRINT( "shut down mode sleep\n" );
    GPIOA_ModeCfg(GPIO_Pin_All,GPIO_ModeIN_Floating);
    RTC_TMRFunCfg(SEND_PERIOD);
    PFIC_EnableIRQ(RTC_IRQn);
    //PWR_UnitModCfg(DISABLE,0x1);
    PWR_PeriphWakeUpCfg( ENABLE, RB_SLP_RTC_WAKE, Edge_ShortDelay );
    DelayMs( 2 );
    LowPower_Shutdown( 0 );                          //ȫϵ磬Ѻλ

    while(1){
        __nop();__nop();
        SYS_ResetExecute();
    }

    return 0;
}
